<?php

defined('_JEXEC') or die('resticted aceess');

class SppagebuilderAddonAddress_list extends SppagebuilderAddons {

    public function render() {
        $settings = $this->addon->settings;

        $title = (isset($settings->title) && $settings->title ) ? $settings->title : '';
        $heading_selector = (isset($settings->heading_selector) && $settings->heading_selector ) ? $settings->heading_selector : 'h3';
        $title_bg = (isset($settings->title_bg) && $settings->title_bg ) ? $settings->title_bg : '';
        $email = (isset($settings->email) && $settings->email ) ? $settings->email : '';
        $phone = (isset($settings->phone) && $settings->phone ) ? $settings->phone : '';
        $location = (isset($settings->location) && $settings->location ) ? $settings->location : '';
        $class = (isset($settings->class) && $settings->class ) ? ' ' . $settings->class : '';

        $output = '<div class="sppb-addon sppb-addon-al' . $class . ' "> ';
        $output .= '<div class="sppb-addon-al-image-wrapper ">';
        if ($title) {
            $output .= '<' . $heading_selector . ' class="sppb-al-title">' . $title . '</' . $heading_selector . '>';
        }
        $output .= '<img class="sppb-img-responsive" src="' . $title_bg . '" alt="' . $title . '" />';
        $output .= '</div>'; //END:: sppb-addon-al-image-wrapper

        $output .= '<div class="sppb-addon-al-additional-infos">';

        // if email has
        if ($email) {
            $output .= '<div class="sppb-addon-al-additional-info">';
            $output .= '<div class="sppb-addon-al-icon">';
            $output .= '<i class="fa fa-envelope"></i>';
            $output .= '</div>';
            $output .= '<div class="sppb-addon-al-text"> ' . $email . ' </div>';
            $output .= '</div>'; //END:: sppb-addon-al-additional-info
        }

        // if phone has
        if ($phone) {
            $output .= '<div class="sppb-addon-al-additional-info">';
            $output .= '<div class="sppb-addon-al-icon">';
            $output .= '<i class="fa fa-phone"></i>';
            $output .= '</div>';
            $output .= '<div class="sppb-addon-al-text">' . $phone . '</div>';
            $output .= '</div>'; //END:: sppb-addon-al-additional-info
        }

        // if location has
        if ($location) {
            $output .= '<div class="sppb-addon-al-additional-info">';
            $output .= '<div class="sppb-addon-al-icon">';
            $output .= '<i class="fa fa-map-marker"></i>';
            $output .= '</div>';
            $output .= '<div class="sppb-addon-al-text">' . $location . '</div>';
            $output .= '</div>'; //END:: sppb-addon-al-additional-info
        }

        $output .= '</div>'; //END:: sppb-addon-al-additional-infos
        $output .= '</div>'; //END:: sppb-addon-al

        return $output;
    }

    public function css() {
        $addon_id = '#sppb-addon-' . $this->addon->id;
        $settings = $this->addon->settings;
        $css = '';
        $title = (isset($settings->title) && $settings->title ) ? $settings->title : '';
        $ai_bg_color = (isset($settings->ai_bg_color) && $settings->ai_bg_color ) ? $settings->ai_bg_color : '';

        $title_style = (isset($settings->title_margin_top) && $settings->title_margin_top ) ? 'margin-top:' . (int) $settings->title_margin_top . 'px;' : '';
        $title_style .= (isset($settings->title_margin_bottom) && $settings->title_margin_bottom ) ? 'margin-bottom:' . (int) $settings->title_margin_bottom . 'px;' : '';
        $title_style .= (isset($settings->title_fontsize) && $settings->title_fontsize ) ? 'font-size:' . $settings->title_fontsize . 'px;line-height:' . $settings->title_fontsize . 'px;' : '';
        $title_style .= (isset($settings->title_text_color) && $settings->title_text_color ) ? 'color:' . $settings->title_text_color . ';' : '';

        if ($title_style && $title) {
            $css .= $addon_id . ' .sppb-al-title {';
            $css .= $title_style;
            $css .= '}';
        }

        if ($ai_bg_color) {
            $css .= $addon_id . ' .sppb-addon-al-additional-infos {';
            $css .= 'background-color: ' . $ai_bg_color . ';';
            $css .= '}';
        }
        return $css;
    }

    public static function geTemplate() {
        $ouput = '
            <#
                let title = (!_.isEmpty(data.title) && data.title ) ? data.title : "";
                let heading_selector = (!_.isEmpty(data.heading_selector) && data.heading_selector ) ? data.heading_selector : "h3";
                let title_bg = (!_.isEmpty(data.title_bg) && data.title_bg ) ? data.title_bg : "";
                let email = (!_.isEmpty(data.email) && data.email ) ? data.email : "";
                let phone = (!_.isEmpty(data.phone) && data.phone ) ? data.phone : "";
                let location = (!_.isEmpty(data.location) && data.location ) ? data.location : "";
                let contentClass = (!_.isEmpty(data.class) && data.class ) ? \' \' + data.class : "";
            #>
                <div class="sppb-addon sppb-addon-al {{contentClass}}">
                <div class="sppb-addon-al-image-wrapper ">
                <# if (title && heading_selector) { #>
                    <{{heading_selector}} class="sppb-al-title" style="margin-top:{{data.title_margin_top}}px;margin-bottom: {{data.title_margin_bottom}}px;font-size: {{data.title_fontsize}}px;line-height:{{data.title_fontsize}}px;color:{{data.title_text_color}};">{{{title}}}</{{heading_selector}}>
                <# } #>
                <img class="sppb-img-responsive" src="{{title_bg}}" alt="{{{title}}}" />
                </div>

                <div class="sppb-addon-al-additional-infos" style="background-color: {{data.ai_bg_color}};">

                <# if (email) { #>
                    <div class="sppb-addon-al-additional-info">
                    <div class="sppb-addon-al-icon">
                    <i class="fa fa-envelope"></i>
                    </div>
                    <div class="sppb-addon-al-text">{{email}}</div>
                    </div>
                <# }

                if (phone) {
                #>
                    <div class="sppb-addon-al-additional-info">
                    <div class="sppb-addon-al-icon">
                    <i class="fa fa-phone"></i>
                    </div>
                    <div class="sppb-addon-al-text">{{phone}}</div>
                    </div>
                <# }

                if (location) {
                #>
                    <div class="sppb-addon-al-additional-info">
                    <div class="sppb-addon-al-icon">
                    <i class="fa fa-map-marker"></i>
                    </div>
                    <div class="sppb-addon-al-text">{{location}}</div>
                    </div>
                <# } #>

                </div>
                </div>
                ';
        return $ouput;
    }

}
